/**
 *  Naken Chat
 *  Author: Michael Kohn
 *   Email: mike@mikekohn.net
 *     Web: http://www.mikekohn.net/
 * License: GPL
 *
 * Copyright 1998-2013 by Michael Kohn
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#ifndef WINDOWS
#include <pthread.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>
#include <netdb.h>
#endif
#include <errno.h>
#include <time.h>
#include <string.h>
#ifdef WINDOWS
#include <windows.h>
#include <process.h>
#include <winsock.h>
#endif

#include "buffered_read.h"
#include "language.h"
#include "message.h"
#include "nakenchat.h"

int buffered_read(int ID)
{
/* char telnet_echo[]={ 255, 251, 34, 255, 250, 34, 1, 1, 240 }; */
/* char telnet_echo[]={ 255, 252, 1 }; */
int r,t=0; 

  while(1)
  {
    errno=0;
    if (users[ID]->bptr>=users[ID]->blen)
    {
#ifdef ENABLE_SSL
      if (users[ID]->flags.ssl_connected)
      {
        users[ID]->blen=SSL_read(users[ID]->ssl, users[ID]->buffer, MAX_MESSAGE_SIZE);
      }
        else
      {
        users[ID]->blen=recv(users[ID]->socketid, users[ID]->buffer, MAX_MESSAGE_SIZE,0);
      }
#else
      users[ID]->blen=recv(users[ID]->socketid, users[ID]->buffer, MAX_MESSAGE_SIZE, 0);
#endif
      users[ID]->bptr=0;

      if (users[ID]->blen==0) return -1;  /* socket is closed */

      if (users[ID]->blen<0)  /* Error occurred */
      {
        users[ID]->blen=0;

/*
        if (users[ID]->inuse==1)
*/

        if (errno==EINTR || errno==EAGAIN) 
        { errno=0; return 0; }

        users[ID]->out_string[0]=0; 
        users[ID]->ptr=0; 

        return -1;
      }

      if (users[ID]->blen>=0) users[ID]->buffer[users[ID]->blen]=0;
    }
  
    for (r=users[ID]->bptr; r<users[ID]->blen; r++)
    { 
      if ((users[ID]->buffer[r]=='\n' || users[ID]->buffer[r]=='\r') || users[ID]->buffer[r]==0)
      { 
/*
        if (t!=0 || users[ID]->buffer[r]==0)
        { t=-1; break; }
*/
        t=-1;
        break;
      }

      if (users[ID]->buffer[r]==127 || users[ID]->buffer[r]==8) 
      { if (users[ID]->ptr>0) users[ID]->ptr--; }
        else
      if (server_info->flags.international==0)
      { if (users[ID]->buffer[r]>=32 && users[ID]->buffer[r]<127) users[ID]->out_string[users[ID]->ptr++]=users[ID]->buffer[r]; }
        else
      { if (users[ID]->buffer[r]>=32 && users[ID]->buffer[r]<255) users[ID]->out_string[users[ID]->ptr++]=users[ID]->buffer[r]; }

      if (users[ID]->ptr>=MAX_MESSAGE_SIZE)
      {
        message(ID,">> Too much input\r\n",0);
        users[ID]->out_string[0]=0;
        kill_user(ID);
        return -1;
      }

      t=1;
    }

    users[ID]->bptr=r+1;

    if ((t==-1 && users[ID]->ptr>0) || users[ID]->ptr>MAX_MESSAGE_SIZE) 
    { 
      users[ID]->out_string[users[ID]->ptr]=0;
      t=users[ID]->ptr;
      users[ID]->ptr=0;
      if (users[ID]->buffer[users[ID]->bptr]=='\n' || 
          users[ID]->buffer[users[ID]->bptr]=='\r')
      { users[ID]->bptr++; }

      return t; 
    }
      else
    { return 0; }
  }
}

