/**
 *  Naken Chat
 *  Author: Michael Kohn
 *   Email: mike@mikekohn.net
 *     Web: http://www.mikekohn.net/
 * License: GPL
 *
 * Copyright 1998-2013 by Michael Kohn
 *
 */

#ifndef NAKENCHAT_H
#define NAKENCHAT_H

#include "server_info.h"
#include "user.h"

#define MAXCONN 100
#define MAX_USER_THREADS 4 
#define MAINCHANNEL "Main"
#define DEFAULT_PORT 6666
#define GC_TIME 300 
#define PASSWORD_LENGTH 20 
#define EMOTE_CHAR '%'
#define WHO_BUFFER_SIZE 250
#define CHANNEL_NAME_LEN 20
#define HIDDEN_CAVES_START 1000
#define HIDDEN_CAVES_END 2000

#define CAN_BE_NOTHING 1
#define NOT_USERID 2

#ifdef WINDOWS
#define CONFIGDIR1 "c:\\Program Files\\nakenchat\\"
#define CONFIGDIR2 "c:\\nakenchat\\"
#else
#define CONFIGDIR1 "/usr/local/etc/"
#define CONFIGDIR2 "/etc/"
#endif

#ifdef WINDOWS
//#define SHUT_RDWR SD_BOTH
#define SHUT_RDWR 2
#endif

#ifndef LOW_MEM_GAGS
#define IS_GAGGED(USER_ID, GAG_ID) (users[USER_ID]->gags[GAG_ID]!=0)
#define NOT_GAGGED(USER_ID, GAG_ID) (users[USER_ID]->gags[GAG_ID]==0)
#define TOGGLE_GAG(USER_ID, GAG_ID) users[USER_ID]->gags[GAG_ID]^=1;
#else
#define IS_GAGGED(USER_ID, GAG_ID) ((users[USER_ID]->gags[GAG_ID/8]&(1<<(GAG_ID%8)))!=0)
#define NOT_GAGGED(USER_ID, GAG_ID) ((users[USER_ID]->gags[GAG_ID/8]&(1<<(GAG_ID%8)))==0)
#define TOGGLE_GAG(USER_ID, GAG_ID) users[USER_ID]->gags[GAG_ID/8]^=(1<<GAG_ID%8)
#endif

#ifdef PLUGINS
#include "naken_plugin.h"

struct naken_plugins_t *naken_plugins;
struct naken_context_t naken_context;
#endif

extern struct _server_info *server_info;

extern struct _user nulluser; 
extern struct _user **users; 

// TODO - move this?
void kill_user(int ID);

#endif

