/**
 *  Naken Chat
 *  Author: Michael Kohn
 *   Email: mike@mikekohn.net
 *     Web: http://www.mikekohn.net/
 * License: GPL
 *
 * Copyright 1998-2013 by Michael Kohn
 *
 */

#ifndef USER_H
#define USER_H

#include <stdint.h>

#define MAX_USER_NAME_LENGTH 17 
#define MAX_MESSAGE_SIZE 512

struct _flags
{
  uint32_t beeps:1;
  uint32_t hilites:1;
  uint32_t squelched:1;
  uint32_t hush_yells:1;
  uint32_t echos:1;
  uint32_t time_stamps:1;
  uint32_t system_messages:1;
  uint32_t hidden_sysop:1;
  uint32_t userlist:1;
  uint32_t changed_name:1;
  uint32_t ssl_connected:1;
};

struct _user
{
  int socketid;
#ifdef ENABLE_SSL
  SSL *ssl;
#endif
  int bptr;
  int blen;
  int ptr;
  int ID;
  int channel;
  union
  {
    struct _flags flags;
    uint32_t uflags;
  };
  time_t logontime;
  time_t idletime;
  time_t stamptime;
#ifdef REALIDLETIME
  time_t real_idletime;
#endif
  int inuse;
  int lastp;
  char user_level;
  char emote_char;
  unsigned char spam;
  unsigned char warnings;
  char location[64];
  char username[MAX_USER_NAME_LENGTH+1];
  char out_string[MAX_MESSAGE_SIZE+64];
  unsigned char buffer[MAX_MESSAGE_SIZE+2];
  unsigned char *gags;
};

void update_list(int ID, int add);
int checkname_dup(char *name, int ID);

#endif

